% Asadi-Pooya Groups By Category
% Comparing us to them
%
% To do
% 1. Category-based Cutoff that maximizes balanced accuracy on
% retrospective
% 2. AUC of sex-UNcorrected category-based cutoff on the prospective
% 3. Recreate their table 2 (System, Score in dx subtype)
%
% Done
% 1. Redo their by-category logistic regression
% 2. Redo their Percent Analysis - controlle for sex

RoS_AllData
close all

%% Specific Parameters
%thca: their categories
dirs.exactmodelsum=[dirs.home 'Asadi_ModelSummaryExact.csv'];
dirs.thcamodelsum=[dirs.home 'Asadi_ModelSummary.csv'];
dirs.catsmodelsum=[dirs.home 'Asadi_ModelSummary14Cat.csv'];
dirs.SupplTable4 =[dirs.home 'Asadi_SupplTable.csv'];
dirs.PerfTable   =[dirs.home 'Asadi_PerfTable.csv'];
n.thca=10;
ix.headsshift=6;

%% Category Titles
fid=fopen(dirs.dataprosp,'r');
h=textscan(fid,'%s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s','Headerlines',0,'Delimiter',',');
fclose(fid);
n.cat=0;
cheads =cell(n.col,1);
cheads2=cell(14,1);
for ind=1:length(h)
    cheads{ind}=h{ind}(1);
    if ~isempty(cheads{ind}{1})
        n.cat=n.cat+1;
        cheads2{n.cat}=cheads{ind}{1};
    end
end

%% Translate into categories
ix.asadi.cats=[9,3,8,5,4,6,7,12,11,15];
asadi.heads={'Skin','HENT','MSK','Pulm','CV','GI','GU','Hem','Psych','CogMem'};
% 9: Skin
% 3: Head & ear, nose, throat
% 8: Musculoskeletal
% 5: Pulmonary
% 4: Cardiovascular
% 6: Gastrointestinal
% 7: Genitourinary
% 12: Hematologic
% 11: Psychiatry
% 15: Cognition & memory
ix.asadi.catix=cell(n.cat+1,1);
cnt.cat=0;
for ind=1:ix.Colmax-1
    if cnt.cat<=n.cat
        if ~isempty(cheads{ind}{1})
            cnt.cat=cnt.cat+1;
        end
        if cnt.cat>0
            ix.asadi.catix{cnt.cat}=[ix.asadi.catix{cnt.cat}, ind];
        end
    end
end
ix.asadi.catix{15}=[ix.asadi.cats(end-1:end)];

%% Create New Data Matrices
data.asadi.retro.cats=zeros(size(data.retro,1),n.cat);
data.asadi.prosp.cats=zeros(size(data.prosp,1),n.cat);
for ind=1:n.cat
    data.asadi.retro.cats(:,ind)=1*(sum(data.retro(:,ix.asadi.catix{ind}-ix.headsshift),2)>0);
    data.asadi.prosp.cats(:,ind)=1*(sum(data.prosp(:,ix.asadi.catix{ind}-ix.headsshift),2)>0);
end
data.asadi.all.cats=[data.asadi.retro.cats;data.asadi.prosp.cats];

data.asadi.retro.thca=zeros(size(data.retro,1),n.thca);
data.asadi.prosp.thca=zeros(size(data.prosp,1),n.thca);
for ind=1:n.thca
    data.asadi.retro.thca(:,ind)=1*(sum(data.retro(:,ix.asadi.catix{ix.asadi.cats(ind)}-ix.headsshift),2)>0);
    data.asadi.prosp.thca(:,ind)=1*(sum(data.prosp(:,ix.asadi.catix{ix.asadi.cats(ind)}-ix.headsshift),2)>0);
end
data.asadi.all.thca=[data.asadi.retro.thca;data.asadi.prosp.thca];

%% Redo their Logistic Regression Models
%10 cats (them but better)
modeldata.X=data.asadi.all.thca(ix.ahasdx,:);
modeldata.Y=1*(data.aclass(ix.ahasdx)>0);
[asadi.b,asadi.dev,asadi.stats]=glmfit(modeldata.X,modeldata.Y,'binomial');
asadi.modelvar={'Int',asadi.heads{:}};
fid=fopen(dirs.exactmodelsum,'w');
fprintf(fid,'Name,Val,p\n');
for ind=1:length(asadi.b)
    fprintf(fid,[asadi.modelvar{ind} ',' num2str(asadi.b(ind)) ',' num2str(asadi.stats.p(ind)) '\n']);
end
fclose(fid);

%Gender, Comorbid, 10 cats (them but a lot better)
modeldata.X=[data.ademo(ix.ahasdx,1) data.ademo(ix.ahasdx,3) data.asadi.all.thca(ix.ahasdx,:)];
modeldata.Y=1*(data.aclass(ix.ahasdx)>0);
[asadi.b,asadi.dev,asadi.stats]=glmfit(modeldata.X,modeldata.Y,'binomial');
asadi.modelvar={'Int','Sex','Comorb',asadi.heads{:}};
fid=fopen(dirs.thcamodelsum,'w');
fprintf(fid,'Name,Val,p\n');
for ind=1:length(asadi.b)
    fprintf(fid,[asadi.modelvar{ind} ',' num2str(asadi.b(ind)) ',' num2str(asadi.stats.p(ind)) '\n']);
end
fclose(fid);

%Gender, Comorbid, 14 cats
modeldata.X=[data.ademo(ix.ahasdx,1) data.ademo(ix.ahasdx,3) data.asadi.all.cats(ix.ahasdx,:)];
[asadi.b,asadi.dev,asadi.stats]=glmfit(modeldata.X,modeldata.Y,'binomial');
asadi.modelvar={'Int','Sex','Comorb',cheads2{:}};
fid=fopen(dirs.catsmodelsum,'w');
fprintf(fid,'Name,Val,p\n');
for ind=1:length(asadi.b)
    fprintf(fid,[asadi.modelvar{ind} ',' num2str(asadi.b(ind)) ',' num2str(asadi.stats.p(ind)) '\n']);
end
fclose(fid);

%% Redo Models with Predictions
modeldata.X=[data.demo(ix.hasdx,1) sum(data.asadi.retro.thca(ix.hasdx,:),2)];
modeldata.Y=1*(data.class(ix.hasdx)>0);
[asadi.b,asadi.dev,asadi.stats]=glmfit(modeldata.X,modeldata.Y,'binomial');
modeldata.Xp=[data.demop(ix.phasdx,1) sum(data.asadi.prosp.thca(ix.phasdx,:),2)];
data.asadi.exact.yhat=glmval(asadi.b,modeldata.Xp,'logit',asadi.stats);
data.asadi.exact.yh  =(data.asadi.exact.yhat>=0.5)*2-1;
fprintf(['Number Categories to overcome Prevalence:' num2str(-1*asadi.b(1)/asadi.b(3)) '\n']);

data.apredytru=(data.aclass(ix.ahasdx)+2)/3*2-1;
data.asadi.simple.yh=2*(sum(data.asadi.all.thca(ix.ahasdx,:),2)>2)-1;

%% Assess Performance
summary.asadi.perf=zeros(5,3,4);
% Index 1:
% 1:Accuracy
% 2:Sensitivity
% 3:Specificity
% 4:PPV
% 5:NPV
% Index 2:
% Mean
% 95% LB
% 95% UB
% Index 3:
% 1: Exact
% 2: Gender, Comorbid, 10 Cat
% 3: Gender, Comorbid, 14 Cat
% 4: Gender, Comorbid, 10%
% 5: Gender, Comorbid, 14%

summary.asadi.perf(1,1,1)=mean(data.asadi.exact.yh.*data.predytru>0);
summary.asadi.perf(1,2,1)=binoinv(0.025,length(data.asadi.exact.yh),summary.asadi.perf(1,1,1))/length(data.asadi.exact.yh);
summary.asadi.perf(1,3,1)=binoinv(0.975,length(data.asadi.exact.yh),summary.asadi.perf(1,1,1))/length(data.asadi.exact.yh);

summary.asadi.perf(2,1,1)=mean(data.asadi.exact.yh(ix.pDxESsm).*data.predytru(ix.pDxESsm)>0);
summary.asadi.perf(2,2,1)=binoinv(0.025,length(ix.pDxESsm),summary.asadi.perf(2,1,1))/length(ix.pDxESsm);
summary.asadi.perf(2,3,1)=binoinv(0.975,length(ix.pDxESsm),summary.asadi.perf(2,1,1))/length(ix.pDxESsm);
summary.asadi.perf(3,1,1)=mean(data.asadi.exact.yh(ix.pDxPNESsm).*data.predytru(ix.pDxPNESsm)>0);
summary.asadi.perf(3,2,1)=binoinv(0.025,length(ix.pDxPNESsm),summary.asadi.perf(3,1,1))/length(ix.pDxPNESsm);
summary.asadi.perf(3,3,1)=binoinv(0.975,length(ix.pDxPNESsm),summary.asadi.perf(3,1,1))/length(ix.pDxPNESsm);
ix.pPP=find(data.asadi.exact.yh==1);
ix.pNP=find(data.asadi.exact.yh==-1);
summary.asadi.perf(4,1,1)=mean(data.asadi.exact.yh(ix.pPP).*data.predytru(ix.pPP)>0);
summary.asadi.perf(4,2,1)=binoinv(0.025,length(ix.pPP),summary.asadi.perf(4,1,1))/length(ix.pPP);
summary.asadi.perf(4,3,1)=binoinv(0.975,length(ix.pPP),summary.asadi.perf(4,1,1))/length(ix.pPP);
summary.asadi.perf(5,1,1)=mean(data.asadi.exact.yh(ix.pNP).*data.predytru(ix.pNP)>0);
summary.asadi.perf(5,2,1)=binoinv(0.025,length(ix.pNP),summary.asadi.perf(5,1,1))/length(ix.pNP);
summary.asadi.perf(5,3,1)=binoinv(0.975,length(ix.pNP),summary.asadi.perf(5,1,1))/length(ix.pNP);

%% New Figure 3
%Figure 3: Performance
% Add other predictive methods (Robles, Balanced Acc)
figure
perfdata=zeros(5,3,3);
perfdata(:,:,1)=[squeeze(summary.perf(:,1,[1 3])), summary.asadi.perf(:,1,1)];
perfdata(:,:,2)=[squeeze(summary.perf(:,2,[1 3])), summary.asadi.perf(:,2,1)];
perfdata(:,:,3)=[squeeze(summary.perf(:,3,[1 3])), summary.asadi.perf(:,3,1)];
bar3=barh(perfdata(5:-1:1,:,1),'BarWidth',1,'FaceColor',[0.5 0.5 0.5],'EdgeColor',[1 1 1]);
set(gca,'fontsize',16);
set(bar3(1),'FaceColor',[0.70 0.3 1],...
    'DisplayName','RoS+Sex+Comorbid');
set(bar3(2),'FaceColor',[0.3 0.8 1],...
    'DisplayName','Robles');
set(bar3(3),'FaceColor',[0.3 0.3 1],...
    'DisplayName','Asadi-Pooya');
legend1 = legend(gca,'show');
hold on
% bar4=barh(chance.perf(5:-1:1,[1 3]),'BarWidth',1,'FaceColor',[0.8 0.8 0.8],'EdgeColor',[1 1 1]);
pos=[-0.22,0,0,.22];
% pos=[-0.14,0,0,0.14];
for jnd=[1 3]
    ebs3=errbar(summary.perf(5:-1:1,1,jnd),(1:5)+pos(jnd),abs(summary.perf(5:-1:1,1,jnd)-summary.perf(5:-1:1,2,jnd)),abs(summary.perf(5:-1:1,1,jnd)-summary.perf(5:-1:1,3,jnd)),'horiz','LineWidth',3,'Color',[0 0 0]);
end
eb3=errbar(summary.asadi.perf(5:-1:1,1,1),(1:5)+pos(4),abs(summary.asadi.perf(5:-1:1,1,1)-summary.asadi.perf(5:-1:1,2,1)),abs(summary.asadi.perf(5:-1:1,1,1)-summary.asadi.perf(5:-1:1,3,1)),'horiz','LineWidth',3,'Color',[0 0 0]);
cha3=barh([chance.perf(5:-1:1,[1 3]), chance.perf(5:-1:1,1)],'BarWidth',1,'FaceColor',[0.8 0.8 0.8],'EdgeColor',[1 1 1]);
hold off
perfstats={'PNES-PV','ES-PV','Specificity','Sensitivity','Accuracy'};
set(gca,'ytick',1:5,'yticklabel',perfstats);
set(gca,'xlim',[0 1],'xtick',0:0.2:1,'xticklabel',{'0%','20%','40%','60%','80%','100%'});

fid=fopen(dirs.PerfTable,'w');
fprintf(fid,'Model-Robles-Asadi,Mean,95 CI\n');
for ind=1:5
    fprintf(fid,[perfstats{6-ind} ',']);
    for fnd=1:3
        for jnd=1:3
            fprintf(fid,[num2str(perfdata(ind,fnd,jnd)) ',']);
        end
    end
    fprintf(fid,'\n');
end
fclose(fid);

%% ROC/AUC
data.asadi.all.thcasum=[sum(data.asadi.retro.thca(ix.hasdx,:),2);sum(data.asadi.prosp.thca(ix.phasdx,:),2)];
ix.asadi.DxPNES=find(data.apredytru==-1);
ix.asadi.DxES  =find(data.apredytru==1);

thresh.asadi=unique(data.asadi.all.thcasum);
n.asadi.thresh=length(thresh.asadi);
data.asadi.ROC=zeros(n.asadi.thresh,2);
data.asadi.AUC=0;
for tnd=1:n.asadi.thresh
    data.asadi.ROC(tnd,1)=sum(data.asadi.all.thcasum(ix.asadi.DxPNES)>=thresh.asadi(tnd))/length(ix.asadi.DxPNES);
    data.asadi.ROC(tnd,2)=sum(data.asadi.all.thcasum(ix.asadi.DxES)>thresh.asadi(tnd))/length(ix.asadi.DxES);
    if tnd>1
        data.asadi.AUC=data.asadi.AUC+(1-data.asadi.ROC(tnd,2))*(data.asadi.ROC(tnd-1,1)-data.asadi.ROC(tnd,1));
    end
end
data.asadi.bacc=(data.asadi.ROC(:,1)+(1-data.asadi.ROC(:,2)))/2;
[data.asadi.baccmax,data.asadi.baccmix]=max(data.asadi.bacc);
data.asadi.ROC(data.asadi.baccmix,:);

%% Supplemental Table 4
summary.asadi.table=zeros(n.thca,n.class+1);
% Index 1: proportion
for cnd=1:n.class
    for fnd=1:n.thca
        summary.asadi.table(fnd,cnd)=sum(data.asadi.all.thca(ix.aclassid{cnd},fnd))/summary.aclasses(cnd,2);
        if cnd==n.class
            tmp=round([summary.asadi.table(fnd,2)*summary.aclasses(2,2),summary.asadi.table(fnd,cnd)*summary.aclasses(cnd,2);
                (1-summary.asadi.table(fnd,2))*summary.aclasses(2,2),(1-summary.asadi.table(fnd,cnd))*summary.aclasses(cnd,2)]);
            [tmph,summary.asadi.table(fnd,cnd+1)]=fishertest(tmp,'tail','both');
        end
    end
end
fid=fopen(dirs.SupplTable4,'w');
fprintf(fid,'Question,ES,PSLE,Inconclusive,Mixed,PNES,p(PNES=ES)\n');
for ind=1:n.thca
    fprintf(fid,[asadi.heads{ind} ',' num2str(summary.asadi.table(ind,5)) ',']);
    fprintf(fid,[num2str(summary.asadi.table(ind,3)) ',' num2str(summary.asadi.table(ind,4)) ',']);
    fprintf(fid,[num2str(summary.asadi.table(ind,1)) ',' num2str(summary.asadi.table(ind,2)) ',']);
    fprintf(fid,[num2str(summary.asadi.table(ind,6)) '\n']);
end
fclose(fid);
